/*
	*
	* Copyright 2020 Britanicus <marcusbritanicus@gmail.com>
	*
	* This file is a part of DesQ project (https://gitlab.com/desq/)
	*

	*
	* This file was a part of IonShell (https://gitlab.com/cubocore/ion/ionde)
	* Suitable modifications have been done to meet the needs of DesQ.
	*

	*
	* This program is free software; you can redistribute it and/or modify
	* it under the terms of the GNU General Public License as published by
	* the Free Software Foundation; either version 3 of the License, or
	* ( at your option ) any later version.
	*

	*
	* This program is distributed in the hope that it will be useful,
	* but WITHOUT ANY WARRANTY; without even the implied warranty of
	* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	* GNU General Public License for more details.
	*

	*
	* You should have received a copy of the GNU General Public License
	* along with this program; if not, write to the Free Software
	* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
	* MA 02110-1301, USA.
	*
*/

#pragma once

#include "DesQRegistry.hpp"
#include "qwayland-wayland.h"

class DesQWaylandRegistryPrivate : public QtWayland::wl_registry {

	public:
		DesQWaylandRegistryPrivate(wl_display *wlDisplay, DesQWaylandRegistry *ptr );
		~DesQWaylandRegistryPrivate();

		void initialize();

	protected:
		void registry_global(uint32_t name, const QString &interface, uint32_t version) override;
		void registry_global_remove(uint32_t name) override;

	private:
		Q_DISABLE_COPY( DesQWaylandRegistryPrivate )
		Q_DECLARE_PUBLIC( DesQWaylandRegistry )

		DesQWaylandRegistry *q_ptr;

		wl_display *m_wlDisplay;
		wl_seat *m_wlSeat;
		wl_compositor *m_wlCompositor;
		zwlr_layer_shell_v1 *m_wlrLayerShell;
		zwlr_foreign_toplevel_manager_v1 *m_wlrToplevelManager;
		zwf_shell_manager_v2 *m_wayfireShell;

		DesQLayerShell *m_layerShell;
		DesQWindowManager *m_winMgr;
};
